// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'

var hokmControllers = angular.module('hokmControllers', []);


var hokmApp = angular.module('hokmApp', ['ionic','openfb','ngRoute','hokmControllers','ngResource', 'ngCordova'])
.filter('split', function() {
        return function(input, splitChar) {
        	
        	if(input == "") return "";
        	if(input.indexOf(splitChar)==-1) return [input];
        	
            // do some bounds checking here to ensure it has that index
            return input.split(splitChar);
        }
    })
    
.factory('Camera', ['$q', function($q) {

  return {
    getPicture: function(options) {
      var q = $q.defer();

      navigator.camera.getPicture(function(result) {
        // Do any magic you need
        q.resolve(result);
      }, function(err) {
        q.reject(err);
      }, options);

      return q.promise;
    }
  }
}])

.config(function($compileProvider){
  $compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|tel):/);
})


.run(function($ionicPlatform, OpenFB, $ionicPopup) {
	OpenFB.init({appId: '121620644539431'} );
	
	 // A confirm dialog
	 showConfirm = function() {
	   var confirmPopup = $ionicPopup.confirm({
		 title: 'Exit?',
		 template: 'Are you sure you want to exit?'
	   });
	   confirmPopup.then(function(res) {
		 if(res) {
		 	navigator.app.exitApp();
		 } else {
		   return 0;
		 }
	   });
 	};
 
  $ionicPlatform.ready(function() {
  


      
      
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
  
  
  
  /*
  
  document.addEventListener("pause", function() {
  	navigator.app.exitApp();
  }, false);
  */
  
 // document.addEventListener("resume", function() {            alert("resume");     }, false);
  
  
		//$ionicPlatform.exitApp();		navigator.app.exitApp();

  
  
  
	  $ionicPlatform.registerBackButtonAction(function (event) {
			event.preventDefault();
			showConfirm();
	}, 100);  
	
		
		var admobid = {};
		if( /(android)/i.test(navigator.userAgent) ) { // for android
			admobid = {
				banner: 'ca-app-pub-6626686421064912/2087814219', // or DFP format "/6253334/dfp_example_ad"
				interstitial: 'ca-app-pub-xxx/yyy'
			};
		} else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
			admobid = {
				banner: 'ca-app-pub-6626686421064912/2087814219', // or DFP format "/6253334/dfp_example_ad"
				interstitial: 'ca-app-pub-xxx/kkk'
			};
		} else { // for windows phone
			admobid = {
				banner: 'ca-app-pub-6626686421064912/2087814219', // or DFP format "/6253334/dfp_example_ad"
				interstitial: 'ca-app-pub-xxx/kkk'
			};
		}
		
		setTimeout(function(){ 
			if(AdMob) AdMob.createBanner( {
				adId: admobid.banner, 
				position: AdMob.AD_POSITION.TOP_CENTER, 
				autoShow: true } );
		 }, 30000);
    
		 
/*

		if(window.plugins && window.plugins.AdMob) {
			setTimeout(function(){ 
                var admob_key = device.platform == "Android" ? "ca-app-pub-6626686421064912/2087814219" : "IOS_PUBLISHER_KEY";
                var admob = window.plugins.AdMob;
                admob.createBannerView( 
                    {
                        'publisherId': admob_key,
                        'adSize': admob.AD_SIZE.BANNER,
                        'bannerAtTop': true
                    }, 
                    function() {
                        admob.requestAd(
                            { 'isTesting': false }, 
                            function() {
                                admob.showAd(true);
                            }, 
                            function() { console.log('failed to request ad'); }
                        );
                    }, 
                    function() { console.log('failed to create banner view'); }
                );
            }, 30000);
        }
    */
              
  
  });
})

hokmApp.config(['$routeProvider',  function($routeProvider) {


  $routeProvider.
  when('/login', {
    templateUrl: 'partials/login.html',
  }).
  when('/play', {
    templateUrl: 'partials/play.html',
    //controller: 'PlayController'
  }).
  when('/username', {
    templateUrl: 'partials/username.html',
    //controller: 'PlayController'
  }).
  when('/register', {
    templateUrl: 'partials/register.html',
    //controller: 'PlayController'
  }).
  when('/new', {
    templateUrl: 'partials/new.html',
    //controller: 'PlayController'
  }).
  when('/dp', {
    templateUrl: 'partials/dp.html',
    //controller: 'PlayController'
  }).
  when('/friends', {
    templateUrl: 'partials/friends.html',
    //controller: 'PlayController'
  }).
   when('/welcome', {
    templateUrl: 'partials/welcome.html',
    //controller: 'PlayController'
  }).
  when('/match/:matchId/game/+:gameId', {
    templateUrl: 'partials/game.html'
  }).
  otherwise({
   redirectTo: '/login'
  });
}]);

//     controller: 'GameController'


hokmApp.config(['$httpProvider', function ($httpProvider) {    
	$httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded; charset=UTF-8';
}]);


hokmApp.factory('userService', function() {
  var user = {
    id: 0,
    username: "",
    name: "",
    dp: "",
    checkStatus: function() {
      
    },

    update: function(id,username,name,dp) {
      user.id = id;
      user.username = username;
      user.name = name;
      user.dp = dp;
    },
    
    updateDP: function(dp) {
      user.dp = dp;
    }
    
  };
  return user;
});


hokmApp.directive('imgDp', function(){
   return function(scope, element, attrs) {
        scope.$watch(attrs.imgDp, function(value) {
        	if(value != undefined){
				element.css({
					'background-image': 'url(http://www.hokm.hokmbuzz.com/images/thumb/' + value +')',
					'background-size' : 'cover'
				});
			}
        });
    };
});

hokmApp.directive('imgDpp', function(){
   return function(scope, element, attrs) {
        scope.$watch(attrs.imgDpp, function(value) {
        	if(typeof value == "undefined" || value == ""){
        		element.attr("src","http://www.hokm.hokmbuzz.com/canvas/img/none.jpg")
        		return true;
        	}else{
        		element.attr("src","http://www.hokm.hokmbuzz.com/images/dp100/"+value)
				return true;
			}
        });
    };
});

hokmApp.directive('imgCard', function(){
   return function(scope, element, attrs) {
        scope.$watch(attrs.imgCard, function(value) {
        	if(value != undefined){
     			
			scope.sound_play("slap");
			
			element.css({
				'background-image': 'url(img/deck/' + value +'.png)',
				'background-size' : 'cover'
			});
				
			/*
			if(value == 0 ){ // no card
				$animate.animate(element, {opacity: 1}, {opacity: 0});
			}else{		
				switch(attrs.id) {
					case "cardA1":
						$animate.animate(element, {opacity: 0, position:"absolute", top:"50px"}, {opacity: 1,  position:"absolute", top:"0px"  });
						break;
					case "cardA2":
						$animate.animate(element, {opacity: 0, position:"absolute", top:"-50px"}, {opacity: 1,  position:"absolute", top:"0px"  });
						break;
					case "cardB1":
						$animate.animate(element, {opacity: 0, position:"absolute", left:"-50px"}, {opacity: 1,  position:"absolute", left:"0px"  });
						break;
					case "cardB2":
						$animate.animate(element, {opacity: 0, position:"absolute", right:"-50px"}, {opacity: 1,  position:"absolute", right:"0px"  });
						break;
				}
     		}
     		*/
     					
     			
     		
     		
     	
        
        
              
              
			}
        });
    };
});



hokmApp.directive('lastimgCard', function(){
   return function(scope, element, attrs) {
        scope.$watch(attrs.lastimgCard, function(value) {
        	if(value != undefined){
     			
				element.css({
					'background-image': 'url(img/deck/' + value +'.png)',
					'background-size' : 'cover'
				});
				
				/*
     			$animate.animate(element, 
					 	 	{opacity: 0}, 
					 	 	{opacity: 1});
				*/	 	 	      
			}
        });
    };
});


// delete
hokmApp.filter('unsafe', ['$sce', function ($sce) {
	return function (val) {
		return $sce.trustAsHtml(val);
	};
}]);
// delete


hokmApp.directive('compile', ['$compile', function ($compile) {
  return function(scope, element, attrs) {
    scope.$watch(
      function(scope) {
        return scope.$eval(attrs.compile);
      },
      function(value) {
        element.html(value);
        $compile(element.contents())(scope);
      }
   )};
  }]);
  
  
  
    
function clean_up_chat(value){
	value = value.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/\"/g,"&quot;")
	value = value.replace(/\s+/g," "); //Replace all double white spaces with single spaces
	value = value.replace(/(\r\n|\n|\r)/gm," "); //replaces line breaks with a space
	return value
}

RegExp.escape = function(str) 
{
  var specials = new RegExp("[.*+?|()\\[\\]{}\\\\]", "g"); // .*+?|()[]{}\
  return str.replace(specials, "\\$&");
}

function smile(text){
	var code=new Array(20);
	var file=new Array(20);
	
	code[0] = ':)';
	file[0] = 'msn_smiley.png';
	code[1] = ':D';
	file[1] = 'msn_laugh.png';
	code[2] = ':O';
	file[2] = 'msn_ooooh.png';
	code[3] = ':P';
	file[3] = 'msn_tongue.png';
	code[4] = ';)';
	file[4] = 'msn_wink.gif';
	code[5] = ':(';
	file[5] = 'msn_sad.png';
	code[6] = ':S';
	file[6] = 'msn_weird.png';
	code[7] = ':|';
	file[7] = 'msn_neutral.png';
	code[8] = ':\'(';
	file[8] = 'msn_cry.gif';
	code[9] = ':$';
	file[9] = 'msn_embarrassed.png';
	code[10] = '(H)';
	file[10] = 'msn_hot.png';
	code[11] = ':@';
	file[11] = 'msn_angry.png';
	code[12] = '(A)';
	file[12] = 'msn_angel.png';
	code[13] = '(6)';
	file[13] = 'msn_devil.png';
	code[14] = '(Y)';
	file[14] = 'msn_thumbup.png';
	code[15] = '(N)';
	file[15] = 'msn_thumbdown.png';
	code[16] = '(L)';
	file[16] = 'msn_heart.png';
	code[17] = '(U)';
	file[17] = 'msn_brheart.png';
	code[18] = '(K)';
	file[18] = 'msn_kiss.png';
	code[19] = '(F)';
	file[19] = 'msn_flower.png';
	
	for (x in code){
		  text = text.replace(RegExp("(" + RegExp.escape(code[x]) + ")", "i"), '<img src="img/smiles/'+file[x]+'">');
	}


	return  text;
}

function readCookie(name) {
	val = window.localStorage.getItem(name);
	exp = window.localStorage.getItem(name + "_exp");
	
	if( val != null && exp != null){
		if(ts() < exp){
			return val;
		}
	}			
	return null;
}

function createCookie(name,value,days) {
	window.localStorage.setItem(name, value);
	window.localStorage.setItem(name + "_exp", ts()+(days*24*60*60));
}
function ts(){
	return Math.round(new Date().getTime() / 1000);	
}

