var hokmControllers = angular.module('hokmControllers', []);

// https://chris-allen-lane.com/blog/post/phonegap-prevent-an-android-devices-screen-from-sleeping

hokmControllers.controller('LoginController', function($scope, $http, userService, OpenFB, $cordovaMedia, $ionicPlatform) {

	$scope.submit = function() {
		angular.element(document.querySelector('#loginLoadingDiv')).css("display","block");
		angular.element(document.querySelector('#loginButtonDiv')).css("display","none");
	
		$http({
			method: 'post',
			dataType: 'json',
			url: 'http://www.hokm.hokmbuzz.com/app/app.php',
			data: 'action=login' +  '&username=' + $scope.username +'&password=' + $scope.password
		}).success(function (data, status, headers, config) {
			if( typeof data["err"] != 'undefined' && data["err"] == 0){
				window.localStorage.setItem("username", $scope.username);
				window.localStorage.setItem("password", $scope.password);
	
				$scope.user.update(data["user_id"],data["userName"],data["user_name"],data["user_dp"]);
				document.location = "#/welcome";			
			}else{
				alert(data["err_msg"]);
				angular.element(document.querySelector('#loginLoadingDiv')).css("display","none");
				angular.element(document.querySelector('#loginButtonDiv')).css("display","block");
			}
		}).error(function (data, status, headers, config) {
			alert("Error connecting with server");
			angular.element(document.querySelector('#loginLoadingDiv')).css("display","none");
			angular.element(document.querySelector('#loginButtonDiv')).css("display","block");
		});
	}


$scope.fbLogin = function() {

	OpenFB.login(function(response) {
		$http({
				method: 'post',
				dataType: 'json',
				url: 'http://www.hokm.hokmbuzz.com/app/loginfb.php',
				data: 'access_token=' + response.authResponse.token 
			}).success(function (data, status, headers, config) {
				if( typeof data["err"] != 'undefined' && data["err"] == 0){
					$scope.user.update(data["user_id"],data["userName"],data["user_name"],data["user_dp"]);
					
					if(data["userName"] == ""){
						document.location = "#/username";
					}else{
						document.location = "#/welcome";	
					}
				}else{
					alert(data["err_msg"]);
				}

			}).error(function (data, status, headers, config) {
				alert("Error connecting with server");

			});
	}, {scope: 'email, user_friends'});

    
}


	$scope.register = function() {
		document.location = "#/register";
	}

		
	$scope.checkStatus = function() {
		angular.element(document.querySelector('#loginLoadingDiv')).css("display","block");
		angular.element(document.querySelector('#loginButtonDiv')).css("display","none");
	
		$http({
			method: 'post',
			dataType: 'json',
			url: 'http://www.hokm.hokmbuzz.com/app/app.php',
			data: 'action=checkStatus'
		
		}).success(function (data, status, headers, config) {
			if( typeof data["err"] != 'undefined' && data["err"] == 0){
				$scope.user.update(data["user_id"],data["userName"],data["user_name"],data["user_dp"]);
				$location.path("#/welcome");
			}else{
				alert(data["err_msg"]);
				angular.element(document.querySelector('#loginLoadingDiv')).css("display","none");
				angular.element(document.querySelector('#loginButtonDiv')).css("display","block");
			}

		}).error(function (data, status, headers, config) {
			alert("Error connecting with server");
			angular.element(document.querySelector('#loginLoadingDiv')).css("display","none");
			angular.element(document.querySelector('#loginButtonDiv')).css("display","block");
		});
	}
	
	// check status ? delete
	// user service ? delete
	$scope.user = userService;
	
	var username = window.localStorage.getItem("username");
	var password = window.localStorage.getItem("password");

	
	if(username != null && password != null){
		$scope.username = username;
		$scope.password = password;
		//$scope.submit();
	}
	
	
	
});



























hokmControllers.controller('UsernameController', ['$scope', '$http', 'userService' , function($scope, $http, userService) {
	$scope.frm = {};
	$scope.frm.username = ""; 
	$scope.frm.password = ""
	$scope.frm.password2 = ""

	$scope.logout = function() {
		$http({
			method: 'post',
			dataType: 'json',
			url: 'http://www.hokm.hokmbuzz.com/app/app.php',
			data: 'action=logout'
		}).success(function (data, status, headers, config) {
			
		})
		document.location = "#/login";
	}


	$scope.submit = function() {

		angular.element(document.querySelector('#loginLoadingDiv')).css("display","block");
		angular.element(document.querySelector('#loginButtonDiv')).css("display","none");
		
		$http({
			method: 'post',
			dataType: 'json',
			url: 'http://www.hokm.hokmbuzz.com/app/app.php',
			data: 'action=username' +  '&username=' + $scope.frm.username + '&password=' + $scope.frm.password + '&password2=' + $scope.frm.password2
		}).success(function (data, status, headers, config) {
			if( typeof data["err"] != 'undefined' && data["err"] == 0){
				window.localStorage.setItem("username", $scope.username);
				window.localStorage.setItem("password", $scope.password);
				document.location = "#/welcome";
			}else{
				alert(data["err_msg"]);
				angular.element(document.querySelector('#loginLoadingDiv')).css("display","none");
				angular.element(document.querySelector('#loginButtonDiv')).css("display","block");
			

			}
		}).error(function (data, status, headers, config) {
			alert("Error connecting with server");
			angular.element(document.querySelector('#loginLoadingDiv')).css("display","none");
			angular.element(document.querySelector('#loginButtonDiv')).css("display","block");
		});
	}
	
}]);















hokmControllers.controller('RegisterController', ['$scope', '$http', 'userService' , function($scope, $http, userService) {
	
	// $scope.reg = {email: "sadasd", user:"", pass:"asd", pass2:"1231", name:"", gender:"", country:"Iran"};
	$scope.rf = {};
	$scope.rf.submitted = false; 
	$scope.rf.email = ""
	$scope.rf.country = "IR"
	$scope.rf.gender = "F"
	
	$scope.back = function() {
		document.location = "#/login";
	}
	
	$scope.submit = function(isValid) {
		$scope.rf.submitted = true; 
		if(!isValid){
			alert("Please fill the form.");
			return 0;
		}
		if($scope.rf.p1 !=  $scope.rf.p2){
			alert("Passwords are not matching.");
			return 0;
		}
		

		angular.element(document.querySelector('#loginLoadingDiv')).css("display","block");
		angular.element(document.querySelector('#loginButtonDiv')).css("display","none");
		
		$http({
			method: 'post',
			dataType: 'json',
			url: 'http://www.hokm.hokmbuzz.com/app/app.php',
			data: 'action=register' +  '&username=' + $scope.rf.username + '&p1=' + $scope.rf.p1 + '&p2=' + $scope.rf.p2 
			+ '&email=' + $scope.rf.email + '&name=' + $scope.rf.user_name + '&gender=' + $scope.rf.gender + '&country=' + $scope.rf.country
		}).success(function (data, status, headers, config) {
			if( typeof data["err"] != 'undefined' && data["err"] == 0){
				alert("Account created. Check your email to activate.");
				window.localStorage.setItem("username", $scope.rf.username);
				window.localStorage.setItem("password", $scope.rf.p1);
				document.location = "#/login";
			}else{
				alert(data["err_msg"]);
				angular.element(document.querySelector('#loginLoadingDiv')).css("display","none");
				angular.element(document.querySelector('#loginButtonDiv')).css("display","block");
				
			}
		}).error(function (data, status, headers, config) {
			alert("Error connecting with server");
			angular.element(document.querySelector('#loginLoadingDiv')).css("display","none");
			angular.element(document.querySelector('#loginButtonDiv')).css("display","block");
		});
	}
	
}]);











hokmControllers.controller('WelcomeController', ['$scope', '$http', 'userService' , function($scope, $http, userService) {
	
	$scope.user = userService; // get users
	
	$scope.logout = function() {
		$http({
			method: 'post',
			dataType: 'json',
			url: 'http://www.hokm.hokmbuzz.com/app/app.php',
			data: 'action=logout'
		}).success(function (data, status, headers, config) {
			
		})
		// window.localStorage.setItem("password", "");		
		document.location = "#/login";
	}

	$scope.new = function() {
		document.location = "#/new";
	}

	$scope.list = function() {
		document.location = "#/play";
	}
	
	$scope.changeDP = function() {
		document.location = "#/dp";
	}

	$scope.playFriends = function() {
		document.location = "#/friends";
	}


	
	
	$scope.quick = function() {
		angular.element(document.querySelector('#quickLoading')).css("display","block");
		angular.element(document.querySelector('#quickButton')).css("display","none");
		
		$http({
			method: 'post',
			dataType: 'json',
			url: 'http://www.hokm.hokmbuzz.com/app/app.php',
			data: 'action=quickplay'
		}).success(function (data, status, headers, config) {
			if( typeof data["err"] != 'undefined' && data["err"] == 0){
				if(data["res"] == "new"){
					document.location = "#/match/"+data["match_id"]+"/game/"+data["game_id"];
					return true;
				}

				if(data["res"] == "join"){

			  	 	$http({
						method: 'post',
						url: 'http://www.hokm.hokmbuzz.com/game/action.php',
						data: 'action=sit' +  '&match_id=' + data["match_id"] + '&chair=' +  data["seat"] + '&user_pass=' 
					}).success(function (data, status, headers, config) {
						angular.element(document.querySelector('#quickLoading')).css("display","none");
						angular.element(document.querySelector('#quickButton')).css("display","block");

						if( typeof data["err"] != 'undefined' && data["err"] == 0){
							document.location = "#/match/" + data["match_id"] + "/game/" + data["game_id"] ;
						}else{
							alert(data["err_msg"]);
						}
					}).error(function(data, status, headers, config) {
						angular.element(document.querySelector('#quickLoading')).css("display","none");
						angular.element(document.querySelector('#quickButton')).css("display","block");
						alert("Error");
					});

					return true;
				}

				alert("Please try again."); // should never happen
				
			}else{
				alert(data["err_msg"]);
			}
			angular.element(document.querySelector('#quickLoading')).css("display","none");
			angular.element(document.querySelector('#quickButton')).css("display","block");
		}).error(function (data, status, headers, config) {
			alert("Error connecting with server");
			angular.element(document.querySelector('#quickLoading')).css("display","none");
			angular.element(document.querySelector('#quickButton')).css("display","block");
		});
	}
	
}]);



































hokmControllers.controller('DpController', ['$scope', '$http', 'userService', '$ionicPlatform', 'Camera' , function($scope, $http, userService, $ionicPlatform, Camera ) {

	$scope.cameraPicture = "";
	$scope.loadingDiv = 0;
	$scope.user = userService;

	$scope.getCamera = function() {
		Camera.getPicture({ quality: 100,
							sourceType:1, // camera
							allowEdit: true,
							targetWidth: 500,
							targetHeight: 500,
							saveToPhotoAlbum: false
							}
	).then(function(imageURI) {
		$scope.cameraPicture= imageURI;
		}, function(err) {
			// alert(err);
		});
	};
	
	
	$scope.getGallery = function() {
		Camera.getPicture({ quality: 75,
							sourceType:0, // lib
							allowEdit: true,
							targetWidth: 500,
							targetHeight: 500,
							saveToPhotoAlbum: false
							}
	).then(function(imageURI) {
		$scope.cameraPicture= imageURI;
		}, function(err) {
			// alert(err);
		});
	};
	

	$scope.savePicture = function() {
		$scope.loadingDiv = 1;
	
		var win = function (r) {
			var myRes = angular.fromJson(r.response);
			if(myRes["err"] == 1){
				alert("Error: " + myRes["err_msg"]);
			}else{
				$scope.user.updateDP(myRes["dp"]);
			}
			$scope.loadingDiv = 0;
			$scope.$apply();
			document.location = "#/welcome";
		}

		var fail = function (error) {
			$scope.loadingDiv = 0;
			alert("An error has occurred: Code = " + error.code);
			$scope.$apply();
		}

		var options = new FileUploadOptions();
		options.fileKey="pic";
		options.fileName=$scope.cameraPicture.substr($scope.cameraPicture.lastIndexOf('/')+1);
		options.mimeType="image/jpeg";

		var params = new Object();
		params.value1 = "test";
		params.value2 = "param";

		options.params = params;
		options.chunkedMode = false;

		var ft = new FileTransfer();
    	ft.upload($scope.cameraPicture, "http://www.hokm.hokmbuzz.com/app/app2.php", win, fail, options);
   	  
	};
	
}]);















hokmControllers.controller('FriendsController', ['$scope', '$http', 'userService', '$ionicPlatform', '$ionicPopup' , '$ionicLoading' , function($scope, $http, userService, $ionicPlatform, $ionicPopup, $ionicLoading ) {

	$scope.cameraPicture = "";
	$scope.loadingDiv = 0;
	$scope.user = userService;
	$scope.match = {id:""};

	$scope.ngf = {speed:15, numWin:3, password:""};
	
	$scope.hostGame = function(){
		
		$scope.loadingShow()
  	 	$http({
			method: 'post',
			url: 'http://www.hokm.hokmbuzz.com/play/new_table.php',
			data: 'password=&speed=15&matchNumWin=7&private=1'
		}).success(function (data, status, headers, config) {
			$scope.loadingHide();
			if(data == null){ 
				$ionicPopup.alert({title: 'Error',subTitle: 'Some error occurred.',});
				return;
			}
			if(data[1] != null){				
				document.location = "#/match/" +  data["match_id"] + "/game/" + data["game_id"] ;
			}else{
				$ionicPopup.alert({title: 'Error',subTitle: data[0]});
			}
			

		}).error(function(data, status, headers, config) {
			$scope.loadingHide();
			$ionicPopup.alert({title: 'Error',subTitle: 'Some error occurred while joining the game.',})
		});	
	}

  	
  	
	 $scope.loadingShow = function() {
		$ionicLoading.show({
		  template: 'Loading...'
		});
	  };
	  $scope.loadingHide = function(){
		$ionicLoading.hide();
	  };
  	
  	
  	
  	
    $scope.joinGame = function() { 
    	if( $scope.match.id == "" || $scope.match.id == 0){
    		$ionicPopup.alert({title: 'Error',subTitle: "Invalid Game ID."})
    		return 0;
    	}
    	
  		$scope.loadingShow()
  		

  	 	$http({
			method: 'post',
			url: 'http://www.hokm.hokmbuzz.com/app/app.php',
			data: 'action=joinFriends&match=' + $scope.match.id
		}).success(function (data, status, headers, config) {
			if( typeof data["err"] != 'undefined' && data["err"] == 0){
				
				
				
					$http({
						method: 'post',
						url: 'http://www.hokm.hokmbuzz.com/game/action.php',
						data: 'action=sit&match_id=' + data["match_id"] + '&chair=W&user_pass='
					}).success(function (data, status, headers, config) {
						$scope.loadingHide();

						if( typeof data["err"] != 'undefined' && data["err"] == 0){
							document.location = "#/match/" + data["match_id"] + "/game/" + data["game_id"] ;
						}else{
							$ionicPopup.alert({title: 'Error',subTitle: data["err_msg"]})
						}
					}).error(function(data, status, headers, config) {
						$scope.loadingHide();
						$ionicPopup.alert({title: 'Error',subTitle: 'Some error occurred while joining the game.',})
					});					
				
				
			}else{
				$scope.loadingHide();
				$ionicPopup.alert({title: 'Error',subTitle: data["err_msg"]})
			}
		}).error(function(data, status, headers, config) {
			$scope.loadingHide();
			$ionicPopup.alert({title: 'Error',subTitle: 'Some error occurred while joining the game.',})
		});	
  		
  		
  		
  		
  		
  		

  	
  	
  	}
  	
  
  


	
}]);
























hokmControllers.controller('PlayController', ['$scope', '$http','$routeParams', '$ionicPopup', '$timeout', '$ionicLoading', 'userService'  ,  function($scope, $http, $routeParams, $ionicPopup, $timeout, $ionicLoading, userService) {
	$scope.user = userService;
	
	
	$scope.back = function(){
		document.location = "#/welcome" ;
	}

	$scope.newGame = function(){
		document.location = "#/new/" ;
	}

	$scope.playCache = "";
  
	  $scope.doRefresh = function() {
  
				$http({
				method: 'get',
				dataType: 'json',
				url: 'http://www.hokm.hokmbuzz.com/play/cache.json?'+Date.now() ,
				cache: false	
			}).success(function (data, status, headers, config) {
				if( typeof data != 'undefined' && data != "" ){
					$scope.playCache = data;
				}else{
					alert("Error. Swipe down to refresh.");
				}
				//$timeout($scope.update_games_info(), 50000,false);
			}).finally(function() {
				$scope.$broadcast('scroll.refreshComplete')
			});
		
	
	  };
  
  
  
  
  
	
  	$scope.update_games_info = function(){
  		// alert("started");

		
		
	}//function update_games_info

	$scope.update_games_info()

	$scope.doRefresh();
  	
$scope.showPopup = function(match_id) {
  	
  $scope.data = {}
  
  

  // An elaborate, custom popup
  var myPopup = $ionicPopup.show({
    template: '<input type="password" ng-model="data.matchPass">',
    title: 'Enter Password',
    subTitle: 'Please enter match password',
    scope: $scope,
    buttons: [
      { text: 'Cancel' },
      {
        text: '<b>Enter</b>',
        type: 'button-positive',
        onTap: function(e) {
          if (!$scope.data.matchPass) {
            e.preventDefault();
          } else {
            return $scope.data.matchPass;
          }
        }
      },
    ]
  });
  myPopup.then(function(res) {
    if(res != undefined){
    	$scope.joinStep2(match_id,1,res);
    }
  });
 }; 
	 
  	$scope.join = function(match_id,pass) {
  		if(pass == 1){
  			var matchPass = $scope.showPopup(match_id);
  		}else{
  			$scope.joinStep2(match_id,0,0);
  		}
  	}
  	
  
    $scope.joinStep2 = function(match_id,pass,password) { 
  		$scope.loadingShow()
  	 	$http({
			method: 'post',
			url: 'http://www.hokm.hokmbuzz.com/game/action.php',
			data: 'action=sit' +  '&match_id=' + match_id + '&chair=W' + '&user_pass=' + password
		}).success(function (data, status, headers, config) {
			$scope.loadingHide();

			if( typeof data["err"] != 'undefined' && data["err"] == 0){
				document.location = "#/match/" + match_id + "/game/" + data["game_id"] ;
			}else{
				$ionicPopup.alert({title: 'Error',subTitle: data["err_msg"]})
			}
		}).error(function(data, status, headers, config) {
			$scope.loadingHide();
			$ionicPopup.alert({title: 'Error',subTitle: 'Some error occurred while joining the game.',})
		});	
  	}
  	
	
  	
  	
 $scope.loadingShow = function() {
    $ionicLoading.show({
      template: 'Loading...'
    });
  };
  $scope.loadingHide = function(){
    $ionicLoading.hide();
  };
  
    	
}]);







hokmControllers.controller('NewController', ['$scope', '$http','$routeParams', '$ionicPopup', '$timeout', '$ionicLoading', 'userService'  ,  function($scope, $http, $routeParams, $ionicPopup, $timeout, $ionicLoading, userService) {
	
	$scope.goBack = function(){
		document.location = "#/welcome/" ;
	}
	
	$scope.ngf = {speed:15, numWin:3, password:""};
	
	$scope.createNewGame = function(){
		
		$scope.loadingShow()
  	 	$http({
			method: 'post',
			url: 'http://www.hokm.hokmbuzz.com/play/new_table.php',
			data: 'password=' + $scope.ngf.password +  '&speed=' + $scope.ngf.speed +   '&matchNumWin=' + $scope.ngf.numWin
		}).success(function (data, status, headers, config) {
			$scope.loadingHide();
			if(data == null){ 
				$ionicPopup.alert({title: 'Error',subTitle: 'Some error occurred.',});
				return;
			}
			if(data[1] != null){				
				document.location = "#/match/" +  data["match_id"] + "/game/" + data["game_id"] ;
			}else{
				$ionicPopup.alert({title: 'Error',subTitle: data[0]});
			}
			

		}).error(function(data, status, headers, config) {
			$scope.loadingHide();
			$ionicPopup.alert({title: 'Error',subTitle: 'Some error occurred while joining the game.',})
		});	
	}

  	
  	
 $scope.loadingShow = function() {
    $ionicLoading.show({
      template: 'Loading...'
    });
  };
  $scope.loadingHide = function(){
    $ionicLoading.hide();
  };
  
    	
}]);








hokmControllers.controller(
	'GameController',
		['$scope',
		'$http',
		'$routeParams', 
		'$interval', 
		'$timeout' , 
		'$location', 
		'$anchorScroll',
		'$ionicLoading',  '$ionicModal', '$ionicScrollDelegate',
		'$cordovaMedia', '$ionicPlatform',
		function($scope, $http, $routeParams, $interval, $timeout, $location, $anchorScroll, $ionicLoading , $ionicModal, $ionicScrollDelegate , $cordovaMedia, $ionicPlatform) {
  
  	$ionicModal.fromTemplateUrl('modal-results.html', {
							scope: $scope,
							animation: 'slide-in-up'
						  }).then(function(modal) {
							$scope.modal = modal;
						  })  	
						  
	$ionicLoading.show({ template: 'Loading Game'});
	setTimeout(function() { $ionicLoading.hide() }, 2000);
	
	// $scope.si = readCookie("PHPSESSID"); // web app
	
	$scope.gameId = $routeParams["gameId"];
	$scope.matchId = $routeParams["matchId"];		$scope.pingTimer = 0; // to send request
	
	$scope.pongTimer = 0;
	$scope.numTryJoin = 0;
	$scope.pingErrTime = 0;
	$scope.pageChange = 0; //to check before running another timeout for get table
	$scope.user_name = "";
	$scope.user_dp = "";	
	$scope.userCardsNum = 12;
	$scope.last_msg_id = 0;
	$scope.rand_num = Math.floor(Math.random()*1000);	
	$scope.data = {userA1:0,userB1:0,userA2:0,userB2:0, table_cards:"",table_cards_last:"", timeLeft:15, game_msg:"Hokm Game", hakem:"", cardsA1:"",cardsB1:"",cardsA2:"",cardsB2:"",private:0, match_id:0};
	$scope.chatArray = new Array(); 
	$scope.userCards = "";
	$scope.delay_start = 0;
	$scope.upQ = [];
	$scope.pending_msg = new Array();
	$scope.model = {};
	$scope.model.chatText = "";
	$scope.chat_is_being_sent = 0;
	$scope.chat_last_sent_time = 0;		
	$scope.model.chat = true;
	$scope.model.sound = "on";
	$scope.model.host = false;
	$scope.which_player= "W"
	$scope.SID = "";
	
	// actual user / which user
	$scope.order=new Array(5);
	$scope.order['A1'] =  new Array(5);
	$scope.order['A2'] =  new Array(5);
	$scope.order['B1'] =  new Array(5);
	$scope.order['B2'] =  new Array(5);
	$scope.order['W'] =  new Array(5);

	$scope.order['A1']['A1']='A1';
	$scope.order['B1']['A1']='B1';
	$scope.order['A2']['A1']='A2';
	$scope.order['B2']['A1']='B2';
	$scope.order['W']['A1']='W';
	
	$scope.order['A1']['A2']='A2';
	$scope.order['B1']['A2']='B2';
	$scope.order['A2']['A2']='A1';
	$scope.order['B2']['A2']='B1';
	$scope.order['W']['A2']='W';
	
	$scope.order['A1']['B1']='B2';
	$scope.order['B1']['B1']='A1';
	$scope.order['A2']['B1']='B1';
	$scope.order['B2']['B1']='A2';
	$scope.order['W']['B1']='W';
	
	$scope.order['A1']['B2']='B1';
	$scope.order['B1']['B2']='A2';
	$scope.order['A2']['B2']='B2';
	$scope.order['B2']['B2']='A1';
	$scope.order['W']['B2']='W';

	$scope.order['W']['A1']='A1';
	$scope.order['W']['B1']='B2';
	$scope.order['W']['A2']='A2';
	$scope.order['W']['B2']='B1';
	$scope.order['W']['W']='W';

	$scope.cardOrder=new Array(4);
	$scope.cardOrder['A1']=0;
	$scope.cardOrder['B1']=1;
	$scope.cardOrder['A2']=2;
	$scope.cardOrder['B2']=3;
			
	$scope.process_play = function(data){
		if(data==null){
			$scope.update_msg('Unknown error. Select card again');
		}else if(data['msg'] !=null){
			$scope.update_msg(data['msg']);
		}
		if(data['userCards']!=null){
			$scope.userCards = data['userCards'];

			// get user card number
			if(data['userCards'] == "" || data['userCards'].indexOf(",") == -1){
				$scope.userCardsNum = 1;
			}else{
				var tmp = data['userCards'].split(",");
				$scope.userCardsNum =  tmp.length;
			} 
		}
		if("err_code" in data){
			if(data["err_code"] == "HOKM_NA") // mobile img/deck/1.gif 
				$scope.update_msg("<b>Hokm:</b> <img class='selectHokm' ng-click='selectHokm(1)' src='img/deck/1.gif'>&nbsp;&nbsp;<img ng-click='selectHokm(2)' class='selectHokm' src='img/deck/2.gif'>&nbsp;&nbsp;<img ng-click='selectHokm(3)' class='selectHokm' src='img/deck/3.gif'>&nbsp;&nbsp;<img ng-click='selectHokm(4)' class='selectHokm' src='img/deck/4.gif'>");
				$scope.data["table_cards"][$scope.cardOrder[$scope.order[$scope.which_player]["A1"]]] = 0;
			if(data["err_code"] == "BAD_CARD")
				$scope.data["table_cards"][$scope.cardOrder[$scope.order[$scope.which_player]["A1"]]] = 0;
		}
	}
	
	$scope.process_chat = function(data){
		if(data != null){
			if(data['chat_msg_sent'] != null){	
				angular.forEach(data["chat_msg_sent"], function(value, key) {
				delete $scope.pending_msg[value];
				});
			}
			if(data['err']==1){
				angular.forEach($scope.pending_msg, function(value, index) { 
				if(value != undefined){
					delete $scope.pending_msg[index];
				}
				});
				$scope.update_msg(data['err_msg'])
			}

			$scope.chat_is_being_sent = 0;	
		}

	}
	
	$scope.process_table_data = function(data) {
			if(data == null ) return 1;
			if($scope.pageChange == 1) return 1;			
			if(data["err"] == 1){
				if(typeof data["err_code"] !== "undefined"){
					if(data["err_code"] == "JOIN"){
						$scope.update_msg("You are not in the game. Joining...");
						$scope.sit("W");
						$scope.numTryJoin = $scope.numTryJoin + 1;
						if($scope.numTryJoin>5){
							$scope.update_msg("Joining Failed.");
							$scope.pageChange = 1; 
							$interval.cancel($scope.timer_interval);
						}
					}
				}else{
					$scope.update_msg(data["err_msg"]);
				}
			}else{ // err if
				$scope.update_msg("");
				if ("nextGameID" in data){
					if(data["nextGameID"] == 1 ){
						if($scope.modal.isShown() == false) $scope.modal.show();
						//$ionicLoading.show({ template: 'Match is over.'});
						// $('#modalEnd').foundation('reveal', 'open'); // web app
						$scope.update_msg("Match is over.");
						setTimeout(function() {
							$scope.modal.remove();
							document.location = "#/welcome/";					
						}, 10000);
					}
					if(data["nextGameID"] != 0 && data["nextGameID"] != 1 ){
						if($scope.modal.isShown() == false) $scope.modal.show();
						//$ionicLoading.show({ template: 'Game is over. Moving to next game.'});
						// $('#modalEnd').foundation('reveal', 'open'); // web app
						$scope.update_msg("Game is over... moving to next game.");
						setTimeout(function() {
							$scope.modal.remove();
							document.location = "#/match/" + $scope.matchId + "/game/" + data["nextGameID"];					
						}, 5000);
					}
				}
				
				//check player
				if(data['user_id'] == data['userA1']) $scope.which_player = 'A1';
				else if(data['user_id'] == data['userA2']) $scope.which_player = 'A2';
				else if(data['user_id'] == data['userB1']) $scope.which_player = 'B1';
				else if(data['user_id'] == data['userB2']) $scope.which_player = 'B2';
				else $scope.which_player = 'W';			
				
				if(data['host_id']== data['user_id']) $scope.model.host = true;
				
				//chat
				new_msg = 0;
				angular.forEach(data["chat_msg"], function(value, key) {
					if( value["id"] > $scope.last_msg_id){
						$scope.sound_play("chat");
						$scope.last_msg_id = value["id"];
						value["message"] = smile(value["message"])
						$scope.chatArray.push(value);
						new_msg=1;	
					}
				});
				if(new_msg==1){
					setTimeout(function() {
					//box = document.getElementById('chatMsgContainer');
					//box.scrollTop = (box.scrollHeight);
					$ionicScrollDelegate.$getByHandle('chatHand').scrollBottom();
					}, 200);			
				}
				
				
				if(data['hakem'] != $scope.data["hakem"]){
					if(data['selectHakemCards']!=null&& data['selectHakemCards']!="" && $scope.data["hakem"] && data['hakem']!="NA"){ //animation for hakem cards
						var selectHakemCards = data['selectHakemCards'].split(",");
						cardTarget = document.getElementById('cardC');
						angular.forEach(selectHakemCards, function(value, index) {
							console.log(value);
							var c_top = "";
							var c_left = "";
							var target = "";
							if(index%4 == 0) target = $scope.order[$scope.which_player]["A1"]
							if(index%4 == 1) target = $scope.order[$scope.which_player]["B2"]
							if(index%4 == 2) target = $scope.order[$scope.which_player]["A2"]
							if(index%4 == 3) target = $scope.order[$scope.which_player]["B1"]
														
							if(target == "A1"){c_top = 40; c_left=-10 }
							if(target == "A2"){c_top = -40; c_left=-10 }
							if(target == "B1"){c_top = -10; c_left=40 }
							if(target == "B2"){c_top = -10; c_left=-40 }
							
							//fix center
							c_top = c_top -30;
							c_left = c_left -20;
							
							//randomize location
							var c_top_r = Math.floor((Math.random() * 10) + 1);
							var c_sign = Math.floor((Math.random() * 2) + 1);
							if(c_sign == 2) c_top_r = c_top_r * -1;
							
							var c_left_r = Math.floor((Math.random() * 10) + 1);
							var c_sign = Math.floor((Math.random() * 2) + 1);
							if(c_sign == 2) c_left_r = c_left_r * -1;
							
							c_top = c_top + c_top_r;
							c_left = c_left + c_left_r;
							setTimeout(function() { cardTarget.innerHTML =  cardTarget.innerHTML + "<img style='top:"+c_top+"px; left:"+c_left+"px' src='img/deck/"+ value +".png'>" ; } , (150*index)+100);
						});
						 setTimeout (function() { cardTarget.innerHTML = "";  $scope.delay_start=0; },(selectHakemCards.length * 150)+2000);
						 $scope.delay_start = (selectHakemCards.length * 150)+2000;
					}
					$scope.data["hakem"] = data['hakem'];
				}
				
				if(
				($scope.data["table_cards"][0] == data["table_cards_last"][0] || $scope.data["table_cards"][1] == data["table_cards_last"][1] || $scope.data["table_cards"][2] == data["table_cards_last"][2] || $scope.data["table_cards"][3] == data["table_cards_last"][3])
				&&
				($scope.data["table_cards"][0]==0||$scope.data["table_cards"][1]==0||$scope.data["table_cards"][2]==0||$scope.data["table_cards"][3]==0)
				&&
				(data["table_cards_last"][0] != 0 && data["table_cards_last"][1] != 0 && data["table_cards_last"][2] != 0 && data["table_cards_last"][3] != 0))
				{
					$scope.upQ.push({table_cards:data["table_cards_last"]});
					$scope.upQ.push(data);
					$scope.updateData();
					$timeout(  function() { $scope.updateData();  } , 1000 + $scope.delay_start);
				}else{
					$scope.upQ.push(data);
					$timeout(  function() { $scope.updateData();  } ,  $scope.delay_start);
				}
	
				
				if((data['userA1']==0) || (data['userA2']==0) || (data['userB1']==0) || (data['userB2']==0)){
					$scope.update_msg("<b>Waiting for more players to join.</b>");
				}else if(data['hakem'] == 'NA'){
					if($scope.model.host == 1){
						$scope.update_msg("<i ng-click='selectHakem()' style='font-weight:bold'>Tap to Start the game</i>");
						$scope.selectHakem();
					}else{
						$scope.update_msg("<b>Waiting for host to Start the game</b>");
					}
				}else{ // game is started
					if(data['hokm']!=null){
						if(data['hokm']==0){
							if($scope.which_player==data['hakem']){
								$scope.getHakemCards();
								$scope.update_msg("<b>Hokm:</b> <img class='selectHokm' ng-click='selectHokm(1)' src='img/deck/1.gif'>&nbsp;&nbsp;<img ng-click='selectHokm(2)' class='selectHokm' src='img/deck/2.gif'>&nbsp;&nbsp;<img ng-click='selectHokm(3)' class='selectHokm' src='img/deck/3.gif'>&nbsp;&nbsp;<img ng-click='selectHokm(4)' class='selectHokm' src='img/deck/4.gif'>");
							}else{
								$scope.update_msg("Waiting for Hakem to select Hokm.");
							}
						}else{
							if($scope.userCards == ""){
								$scope.submitCard(1);
							}
						}
					}	
				}
			}  // err if
  	}


	$scope.msgUpdate =0;
	
	$scope.update_msg =  function (str) {
		//console.log("update message " + str);
		if(str == "" && $scope.msgUpdate > (ts()-10) ) return 0;
		
		$scope.game_msg = str;
		
		if(str != ""){
			// $("#msgArea").addClass("orangeBg");
			//setTimeout(function() {
			//	$("#msgArea").removeClass("orangeBg");
			// }, 400);
			$scope.msgUpdate = ts();
		}
	}	
		
  $scope.sendChat = function() {
  	m = clean_up_chat($scope.model.chatText);
	$scope.pending_msg.push(m);
	$scope.chatArray.push({name:$scope.user_name, message:smile(m), id: $scope.pending_msg.length-1, dp:$scope.user_dp});
	$scope.model.chatText = "";
	
	setTimeout(function() {
	//box = document.getElementById('chatMsgContainer');
	//box.scrollTop = (box.scrollHeight);
	$ionicScrollDelegate.$getByHandle('chatHand').scrollBottom();
	}, 200);	
  }
  

  $scope.checkSendChat = function() {
  if($scope.chat_is_being_sent == 0 || $scope.chat_last_sent_time + 15 < ts() ){
	// Making Json for chat msgz
	var pending_msg_json = '{';
	if($scope.pending_msg.length != 0){
		angular.forEach($scope.pending_msg, function(value, key) {
			if(value != undefined)
				pending_msg_json += '"' +  key + '"' + ':' + '"'  + value + '",' ;
		});
	}
	pending_msg_json = pending_msg_json.substr(0, pending_msg_json.length-1);
	pending_msg_json += '}';
	
	
	if(pending_msg_json!= '}'){
		$scope.chat_is_being_sent = 1;
		$scope.chat_last_sent_time = ts();
		
		if($scope.useLP == 1){  
			$http({ url: 'http://www.hokm.hokmbuzz.com/game/chat/?match_id='+$scope.matchId+'&pending_msg='+encodeURIComponent(pending_msg_json), method: 'get', cache: false, dataType: 'json', timeout: 12000
			}).error(function(data, status, headers, config) { $scope.chat_is_being_sent = 0;})	
			.success(function (data, status, headers, config) { $scope.process_chat(data); });
		}else{
			$scope.ws.send('{"action":"chat", "pending_msg": "' + encodeURIComponent(pending_msg_json)  + '"}')
		}
		
	} // if
	} //if
  } // check sned chat
  
  $scope.clearUser = function(user) {
    $scope.data["dp"+user]="";
  }

   $scope.updateData = function() {
     var data = $scope.upQ.shift();
     if(data == undefined) return 0;
	 for(var key in data) {
		$scope.data[key] = data[key];
	 }
	if(data['userA1']==0) $scope.clearUser("A1");
	if(data['userA2']==0) $scope.clearUser("A2");
	if(data['userB1']==0) $scope.clearUser("B1");
	if(data['userB2']==0) $scope.clearUser("B2");

	if(data['userCards']!=null){
		$scope.userCards = data['userCards'];

		// get user card number
		if(data['userCards'] == "" || data['userCards'].indexOf(",") == -1){
			$scope.userCardsNum = 1;
		}else{
			var tmp = data['userCards'].split(",");
			$scope.userCardsNum =  tmp.length;
		} 
	}
		
//	$(document).foundation('tooltip', 'reflow'); // web app
}

$scope.$on('$locationChangeStart', function(){   
	$scope.pageChange = 1; 
	$interval.cancel($scope.timer_interval);
	$ionicLoading.hide(); // mobile
});


$scope.publishFB = function() {
	$scope.httpProm = $http({
	url: 'http://www.hokm.hokmbuzz.com/match/post.php',
	data: "action=kout&game_id=" + $scope.gameId,
	method: 'POST',
	cache: false,
	dataType: 'json',
	timeout: 15000
})
.success(function (data, status, headers, config) {
	if("err" in data && data['err'] == 0){
		$scope.validFB = 1;
	}
})
}



$scope.leaveGame = function(){
	$scope.makeAction("action=stand&match_id=" + $scope.matchId )
	document.location = "#/welcome/" ;
}

$scope.exit = function(){
	$scope.makeAction("action=stand&match_id=" + $scope.matchId )
	setTimeout(function() { document.location = "#/welcome" ;}, 1000);
}

$scope.sit = function(chair){
	$scope.makeAction("action=sit&match_id=" + $scope.matchId + "&chair=" + $scope.order[$scope.which_player][chair] )
}

$scope.addRobot = function(chair){
	$scope.makeAction("action=add_robot&match_id=" + $scope.matchId + "&chair=" + $scope.order[$scope.which_player][chair] )
}

  
$scope.stand = function(){
	$scope.makeAction("action=stand&match_id=" + $scope.matchId )
}

$scope.kick = function(user){
	$scope.makeAction("action=stand&match_id=" + $scope.matchId + "&user_id=" + user )
}
  
$scope.ban = function(user){
	$scope.makeAction("action=ban&match_id=" + $scope.matchId + "&user_id=" + user )
}


$scope.selectHakem = function(){
	$scope.makeAction("action=selectHakem&match_id=" + $scope.matchId )
}

$scope.set_host = function(){
	$scope.makeAction("action=set_host&match_id=" + $scope.matchId )
}

$scope.change_open = function(change_user_id,open_mode){
	if(open_mode == 1){
		open_mode = 0;
	}else{
		open_mode = 1;
	}
	$scope.makeAction("action=change_open&match_id=" + $scope.matchId + "&change_user_id=" + change_user_id + "&open_mode=" + open_mode )
}

//if(userA1==change_user_id) userA1 =0;
//if(userB1==change_user_id) userB1 =0;
//if(userA2==change_user_id) userA2 =0;
//if(userB2==change_user_id) userB2 =0;

$scope.makeAction = function(param) {
	$scope.httpProm = $http({
	url: 'http://www.hokm.hokmbuzz.com/game/action.php?',
	data: param,
	method: 'POST',
	cache: false,
	dataType: 'json',
	timeout: 15000
}).error(function(data, status, headers, config) {
	$scope.update_msg("connection error (1000)");
})
.success(function (data, status, headers, config) {
	if(data['err']!=null && data['err']!=0 && data['err_msg']!=null  ){
		$scope.update_msg(data['err_msg']);
	}
})
}
  
$scope.selectHokm = function(hokm) {
	$scope.httpProm = $http({
	url: 'http://www.hokm.hokmbuzz.com/game/files/select_hokm.php?',
	data: "game_id=" + $scope.gameId + "&hokm=" + hokm,
	method: 'POST',
	cache: false,
	dataType: 'json',
	timeout: 15000
}).error(function(data, status, headers, config) {
	$scope.update_msg("Error 1117");
})
.success(function (data, status, headers, config) {
	if(data['res']==1){
		$scope.update_msg("Hokm selected.");
		$scope.submitCard(1);
	}else{
		$scope.update_msg(data['error']);
	}	
		
})
}

  $scope.getHakemCards = function(hokm) {
	$http({
		url: 'http://www.hokm.hokmbuzz.com/game/files/select_hokm.php',
		data: "game_id=" + $scope.gameId + "&cards=1",
		method: 'POST',
		cache: false,
		dataType: 'json',
		timeout: 15000
	}).error(function(data, status, headers, config) {
		$scope.update_msg("Error 1139");
	})
	.success(function (data, status, headers, config) {
		if(data!=null){
			$scope.userCards = data['userCards'].join();
			$scope.userCardsNum =  data['userCards'].length;
		}
	})

  }
  

  $scope.submitCard = function(card) {
  	if(card != 1){
  		$scope.data["table_cards"][$scope.cardOrder[$scope.order[$scope.which_player]["A1"]]] = card;
  	}
  	if($scope.useLP == 1){  
		$http({ url: 'http://www.hokm.hokmbuzz.com/game/play/', data: "game_id=" + $scope.gameId + "&card=" + card, method: 'POST', cache: false, timeout: 15000 })
		.error(function(data, status, headers, config) { update_msg('Network Error'); })
		.success(function (data, status, headers, config) { $scope.process_play(data) })
  	}else{
		$scope.ws.send('{"action":"play","game_id":' +  $scope.gameId + ',"card":' +  card + '}')  	
	}
	
  }
  
  
  $scope.switch_sound = function() {
	if($scope.model.sound=="on"){
		$scope.model.sound = "off";
	}else{
		$scope.model.sound = "on";
	}
  }
  

  $scope.sound_play = function(ev) {
	if($scope.model.sound=="on"){
		// document.getElementById('player_'+ev).play()	
		try {
			if(ev == "slap") $scope.media_card.play();
			if(ev == "chat") $scope.media_chat.play();
		}
		catch(err) {
		
		}
	}
  }
  
	$scope.start = function() {
		//reset
		$scope.pingTimer = 0;
		$scope.pongTimer = 0;
		$scope.wsWorks = 0;
		
		setTimeout(function() {	if($scope.wsWorks == 0){ $scope.LP_check_update_table(); createCookie("useLP",1,14); $scope.useLP = 1; }	}, 8000);


		 $scope.ws = new WebSocket("wss://hokm.hokmbuzz.com:9001/hokm?si="+ $scope.SID +"&game_id="+$scope.gameId+"&match_id="+$scope.matchId+"&rand_num="+$scope.rand_num);
		 $scope.ws.onopen = function() {
			 //console.log('open');
		 };


		$scope.ws.onmessage = function (evt) {
			$scope.update_msg("");
			//console.log(evt.data);
			var res = JSON.parse(evt.data)
			//console.log(res);
			//res = evt.data;
			if(res.err == "1"){
				if(typeof res.err_code !== "undefined"){
					switch(res.err_code) {
						case "JOIN":
							$scope.update_msg("You are not in the game. Joining...");
							$scope.sit("W");
							$scope.numTryJoin = $scope.numTryJoin + 1;
							if($scope.numTryJoin>5){
								$scope.update_msg("Joining Failed.");
								$scope.pageChange = 1; 
								$interval.cancel($scope.timer_interval);
								setTimeout(function() {	 $scope.ws.close(); }, 1500);
							}
							break;
					}
				}else{
					$scope.update_msg(res.err_msg);
				}				
				
			}
			switch(res.type) {
				case "table":
					$scope.process_table_data(res.data);
					break;
    			case "play":
    				$scope.process_play(res.data);
    				break;
    			case "chat":
    				$scope.process_chat(res.data);
    				break;
    			case "pong":
    				$scope.wsWorks = 1;
    				$scope.pongTimer = 0;
    				break;
    		}			
		};
		$scope.ws.onclose = function() { 
			$scope.update_msg("Connection closed")
		};
	}


	$scope.timer = function() {
		if($scope.useLP == 1){
			// $scope.LP_check_update_table();
		}else{
			//console.log("pong: " + $scope.pongTimer  + " ping: " + $scope.pongTimer);
			if($scope.pongTimer > 15){
				$scope.update_msg("Server has gone away");
				if($scope.pingErrTime + 10 < ts()){
					$scope.start();
					$scope.pingErrTime = ts();
				}
			}
			$scope.pongTimer = $scope.pongTimer + 1;
			$scope.pingTimer = $scope.pingTimer + 1;
			if($scope.pingTimer > 9 ) $scope.ping();
		}
		
		$scope.checkSendChat();
		if($scope.data["timeLeft"] != 0) $scope.data["timeLeft"] = $scope.data["timeLeft"] - 1;
	} 
	
	$scope.ping = function(data){
		$scope.pingTimer = 0;
		try {
			//console.log("send ping");
			$scope.ws.send('{"action":"ping"}')
		} catch(err) {
			//console.log(err.message);
		}
	}
	

	

	
	$scope.get_table_con = null;
	$scope.table_update_time = 0;
		
	$scope.LP_check_update_table = function(){
		if($scope.pageChange == 0) $scope.LP_get_table();
	}
	
	
	$scope.LP_get_table = function(){
		$scope.table_update_time = ts();
		//if($scope.get_table_con != null && $scope.get_table_con.readyState != 4) $scope.get_table_con.abort();
		$scope.get_table_con = $http({ url: 'http://www.hokm.hokmbuzz.com/game/get/?game_id='+$scope.gameId+'&match_id='+$scope.matchId+'&last_msg_id='+$scope.last_msg_id+'&rand_num='+$scope.rand_num,method: 'get',cache: false,dataType: 'json',timeout: 30000})	
		.success(function (data, status, headers, config) { $scope.process_table_data(data); $scope.table_update_time = ts(); })
		.then(function(data, status, headers, config){ $scope.LP_check_update_table(); });
	} //function




	$ionicPlatform.ready(function() {
		try {
			if(ionic.Platform.isAndroid()){
				$scope.media_card = $cordovaMedia.newMedia("/android_asset/www/sound/slap_card.mp3");
				$scope.media_chat = $cordovaMedia.newMedia("/android_asset/www/sound/chat_tick.mp3");
			}else{
				$scope.media_card = $cordovaMedia.newMedia("sound/slap_card.mp3");
				$scope.media_chat = $cordovaMedia.newMedia("sound/chat_tick.mp3");
			}
		}
		catch(err) {
			//alert(err);
		}
		
		$scope.useLP = 1;
		if(readCookie("useLP") != null && readCookie("useLP")!=0 ) $scope.useLP = 1;
		
		//$(document).foundation(); // web app
		// $(document).foundation('topbar', 'reflow'); // web app
	
		//Get match score
		$http({
			method: 'post',
			dataType: 'json',
			url: 'http://www.hokm.hokmbuzz.com/app/app.php',
			data: 'action=getMatch&match_id=' + $scope.matchId
		}).success(function (data, status, headers, config) {
			if(data["err"] == 1){
				$scope.update_msg("Error connecting with server. (481)");
			}else{
				$scope.data["private"] = data["private"];
				$scope.data["match_id"] = $scope.matchId;
				$scope.data["scoreA"] = data["scoreA"];
				$scope.data["scoreB"] = data["scoreB"];
				$scope.data["lastGameID"] = data["lastGameID"];
				$scope.user_name = data["user_name"];
				$scope.user_dp = data["user_dp"];
				$scope.validFB = data["validFB"];
				$scope.SID = data["SID"];
				
				// start the game
				$scope.timer_interval = $interval(function(){ $scope.timer(); }, 1000 );
				if($scope.useLP == 0) $scope.start();
				if($scope.useLP == 1) $scope.LP_check_update_table();
				
				if( $scope.data["private"] == 1){
					  $scope.modalPrivate = $ionicModal.fromTemplate('<ion-modal-view><div style="text-align:center; line-height: 2; font-weight:bold"> <br> <h1>Invite Friends</h1> <div style="font-size:1.2em">Ask your friends to join using Game ID:</div> <div style="font-size:4em; color:#C91A1A"> {{ data["match_id"] | limitTo:-4 }} </div>  <button class="button button-stable" ng-click="modalPrivate.remove()">&nbsp; &nbsp; Ok! &nbsp; &nbsp; </button>	   </div></ion-modal-view>', {
						scope: $scope,
						animation: 'slide-in-up'
					  })
					$scope.modalPrivate.show();
				}
			}
		}).error(function (data, status, headers, config) {
			$scope.update_msg("Error connecting with server (706)");
		});

	});


  

}]);
